export const formatParams = (uploadList) => {
  // 上传文件formData类型
  const uploadFileTypeEm = {
    image: 'image',
    video: 'video',
    file: 'file',
    text: 'text',
  }
  let mediaList = [] // 媒体文件 参数中的content
  let fileList = [] // 文档文件
  uploadList.forEach((item) => {
    if (item.uploadFileType === uploadFileTypeEm.image) {
      // 图片
      let media = {
        type: 'image_url',
        image_url: {
          url: item.ori_url,
        },
      }
      mediaList.push(media)
    } else if (item.uploadFileType === uploadFileTypeEm.video) {
      // 视频
      let media = {
        type: 'video_url',
        video_url: {
          url: item.url,
        },
      }
      mediaList.push(media)
    } else if (item.uploadFileType === uploadFileTypeEm.file) {
      let file = {
        role: 'system',
        content: item.url,
        mask: 'new',
      }
      fileList.push(file)
    }
  })
  return { media: mediaList, file: fileList }
}
export const calcFileSize = (size: number) => {
  const type = ['B', 'KB', 'MB', 'GB', 'TB']
  // for(let i=0;i<type.length && size>1024;i++){
  // 	size/=1024
  // }
  let unit = 'B'
  while (size > 1024) {
    size /= 1024
    unit = type.shift()
  }
  return `${Math.ceil(size)}${unit}`
}
