import { getEnvBaseUrl } from "./index";
export const baseUrl =getEnvBaseUrl();
// 获取接口（application/json，带token）
export const api = (url = '', params = {}, method = 'post') => {
  let token = wx.getStorageSync('token'); 
  return new Promise((resolve, reject) => {
    wx.request({
      url: baseUrl+url,
      data: params,
      method,
      header: {
        'Content-Type': "application/json",
        'token': token,
      },
      complete: res => {
        if(res.statusCode == 200) {
          resolve(res.data)
        } else {
          reject(res)
        }
      }
    })
  })
}
// 获取接口(application/x-www-form-urlencoded,带token)
export const api_form = (url = '', params = {}, method = 'post') => {
  let token = wx.getStorageSync('token');
  return new Promise((resolve, reject) => {
    wx.request({
      url: baseUrl+url,
      data: params,
      method,
      header: {
        'Content-Type':"application/x-www-form-urlencoded",
        'token': token,
      },
      complete: res => {
        if(res.statusCode == 200) {
          resolve(res.data)
        } else {
          reject(res)
        }
      }
    })
  })
}
// 获取接口(application/x-www-form-urlencoded,不带token)
export const apis = (url = '', params = {}, method = 'post') => {
  return new Promise((resolve, reject) => {
    wx.request({
      url: baseUrl+url,
      data: params,
      method,
      header: {
        'Content-Type':"application/x-www-form-urlencoded",
      },
      complete: res => {
        if(res.statusCode == 200) {
          resolve(res.data)
        } else {
          reject(res)
        }
      }
    })
  })
}
// 时间戳转日期（年月日）
 export const  time_format = (time) =>{
  // 判断时间戳是否为13位数，如果不是则*1000，时间戳只有13位数(带毫秒)和10(不带毫秒)位数的
  if(time.toString().length == 13){
    var tme = new Date(time);
  }else{
    var tme = new Date(time * 1000);
  }
  var Y = tme.getFullYear();
  var M = (tme.getMonth() + 1 < 10 ? '0' + (tme.getMonth() + 1) : tme.getMonth() + 1);
  var D = tme.getDate();
  var h = tme.getHours();
  var m = tme.getMinutes();
  var s = tme.getSeconds();
  var tem1 = Y + '-' + M + '-' + D  
  // + h + '时' + m + '分' 
  // + s +'秒'
  return tem1;
 }
 export const  time_format3 = (time) =>{
  // 判断时间戳是否为13位数，如果不是则*1000，时间戳只有13位数(带毫秒)和10(不带毫秒)位数的
  if(time.toString().length == 13){
    var tme = new Date(time);
  }else{
    var tme = new Date(time * 1000);
  }
  var Y = tme.getFullYear();
  var M = (tme.getMonth() + 1 < 10 ? '0' + (tme.getMonth() + 1) : tme.getMonth() + 1);
  var D = tme.getDate();
  var h = tme.getHours();
  if(h<10){
    h='0'+h;
  }
  var m = tme.getMinutes();
  if(m<10){
    m='0'+m;
  }
  var s = tme.getSeconds();
  if(s<10){
    s='0'+s;
  }
  var tem1 = Y + '-' + M + '-' + D +' '+h+':'+m+':'+s 
  // + h + '时' + m + '分' 
  // + s +'秒'
  return tem1;
 }
//  时间戳转日期（时分）
 export const  time_format1 = (time) =>{
  if(time.toString().length == 13){
    var tme = new Date(time);
  }else{
    var tme = new Date(time * 1000);
  }
  var Y = tme.getFullYear();
  var M = (tme.getMonth() + 1 < 10 ? '0' + (tme.getMonth() + 1) : tme.getMonth() + 1);
  var D = tme.getDate();
  var h = tme.getHours();
  var m = tme.getMinutes();
  var s = tme.getSeconds();
  var tem2 =  + h + '时' + m + '分'
  // + s +'秒'
  return tem2;
 }
//  时间戳转日期（时分 00:00格式）
 export const toHHmmss= (data)=> {
  var time;
  var hours = parseInt((data % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
  var minutes = parseInt((data % (1000 * 60 * 60)) / (1000 * 60));
  // var seconds = (data % (1000 * 60)) / 1000;
  time = (hours < 10 ? ('0' + hours) : hours) + ':' + (minutes < 10 ? ('0' + minutes) : minutes) ;
  return time;
}
// 错误toast提示
export const showToastErr = (title,mask=false) =>{
  wx.showToast({
      title: title,
      icon: 'none',
      duration: 1500,
      mask:mask
  });
}
export function showToastErrMask(title){

  wx.showToast({
    title:title,
    icon:"none",
    duration:1500,
    mask:true
  })
}
// export function showToastErrMask(title){
//   wx.showToast({
//     title: title,
//     icon:"none",
//     duration:1500,
//     mask:false
//   })
// }
// 成功toast提示
export const showToastOk = (title,mask=false) =>{
  wx.showToast({
      title: title,
      icon: 'success',
      duration: 1500,
      mask:mask
  });
}  
export function showToastOkMask(title){ 
  // 用于不需要控制用户点击频率时
  wx.showToast({
    title:title,
    icon:"success",
    duration:1500,
    mask:true 
  })
}
// 上传图片
export const uploadFile = (url,file)=>{
  let token = wx.getStorageSync('token');
  return new Promise((resolve, reject) => {
    wx.uploadFile({
      url: baseUrl+ url,
      filePath: file,
      name: "file",
      header: {
        "Content-Type": "application/x-www-form-urlencoded",
        'token': token,
      },
     complete: (res) => {
      if(res.statusCode == 200) {
        resolve(res)
      } else {
        reject(res)
      }
    }
    })
  })
}
// 上传图片(选择图片)
export const selectPic = ()=>{
  return new Promise((resolve,reject) => {
    wx.chooseImage({
      count: 4, //默认9
      sizeType: ["original", "compressed"], //可以指定是原图还是压缩图，默认二者都有
      sourceType: ["album", "camera"], //从相册选择
      success: function (res) {
        resolve(res)
      },
      fail:function(){
        reject("选择文件失败")
      }
    })
  })
}
// 日期字符串添加年月日
export const times=(strTime, type)=> {
  // 字符串转数组
  var strTimes = strTime.split(type)
  strTimes[0] = strTimes[0] 
  strTimes[1] = strTimes[1]
  strTimes[2] = strTimes[2] 
  // 数组转字符串
  strTimes = strTimes.join(type)
  return strTimes
 }
 export const times1=(strTime, type)=> {
  // 字符串转数组
  var strTimes = strTime.split(type)
  strTimes[0] = strTimes[0] + '年'
  strTimes[1] = strTimes[1] + '月'
  strTimes[2] = strTimes[2] + '日'
  strTimes[2] = strTimes[3] + '时'
  strTimes[2] = strTimes[4] + '分'
  strTimes[2] = strTimes[5] + '秒'
  // 数组转字符串
  strTimes = strTimes.join(type)
  return strTimes
 }
//  登录
 export const login = () => {
  return new Promise(function (resolve, reject) {
    wx.login({
      success: function (res) {
        if (res.code) {
          resolve(res);
        } else {
          reject(res);
        }
      },
      fail: function (err) {
        reject(err);
      },
    });
  });
};
// 模态框
export  const Modal=(title,content)=> {
  return new Promise((resolve,reject)=>{
    wx.showModal({
      title: title,
      content: content,
       success: function(res) { 
        if(res.confirm) { 
          resolve(res.confirm)
        } else if(res.cancel) { 
          reject(res.cancel)
        }
      },
      fail: function(rej){
        reject(rej)
      }
    })
  })  
}
// 获取个人信息
 export const getUserInfo=()=> {
  return new Promise((resolve, reject) => {
    wx.getUserInfo({
      desc: '用于完善会员资料',
      success: function (res) {
        if (res) {
          resolve(res);
        } else {
          reject(res);
        }
      },
      fail: function (err) {
        reject(err);
      },
    })
  })
};
export function navigateTo(url) {
  wx.navigateTo({
   url: `/pages/${url}/${url}`
  })
 }
 export function reLaunch(url) {
  wx.reLaunch({
    url: `/pages/${url}/${url}`
   })
 }
 
 // 日期转时间戳
 export const  date_stamp=(time)=> new Date(time).getTime()/1000

 export function travelTree(tree,arr) {
  for (let item of tree) {
     arr.push(item.label);
     if (item.children&& item.children.length) travelTree(item.children,arr);
  }
  return arr;
}
export function getToday(){
  let date=new Date();
  let year=date.getFullYear();
  let month=date.getMonth();
  let day=date.getDate();
  return `${year}-${month}-${day}`;
}

// 重定向到某个页面
export function redirectTo(nextUrl){
  wx.redirectTo({
    url: nextUrl,
  })
} 
export function showloading(title=""){
  wx.showLoading({
    title:title,
    mask:true
  })
}
export function hideloading(){
  wx.hideLoading()
}

// 获取用户授权权限
export function getLimit(){
  return new Promise((resolve,reject)=>{
    wx.getSetting({
      withSubscriptions:true,
      success:function(res){
        if(res){
          resolve(res)
        }else{
          reject(res)
        }
      },
      fail:(rej)=>{
        reject(rej)
      }
    })
  })
}

// 开启订阅
export function subscribe(id){ 
  return new Promise((resolve,reject)=>{
      wx.requestSubscribeMessage({
    tmplIds: id,
    success:function(res){ 
      if(res){ 
        resolve(res)
      }else{ 
        reject(res)
      }
    },
    fail:function(rej){ 
      reject(rej)
    }
  })
  })
}

export const chooseMsgFile=()=>{
    return new Promise((resolve,reject)=>{
        wx.chooseMessageFile({
          count: 100,
          type:"all",
          success(res){
              if(res){
                  resolve(res)
              }else{
                  reject(res)
              }
          },
          fail(rej){
              reject(rej)
          },
          complete(res){
              if(res){
                  resolve(res)
              }else{
                  reject(res)
              }
          }
        })
    })
}

// 拍摄或者从相册上传
export const chooseMedia=(count=9)=>{
    return new Promise((resolve,reject)=>{
        wx.chooseMedia({
            count:count,
            mediaType:["image"],
            sourceType:['album', 'camera'],
            camera:"back",
            success(res){
                if(res){
                    resolve(res)
                }else{
                    reject(res)
                }
            },
            fail(rej){
                reject(rej)
            },
            complete(res){
                if(res){
                    resolve(res)
                }else{
                    reject(res)
                }
            }
        })
    })
}